//
//  BLEManager.h
//
//  ------------------------------------------------------------------
//  内部函数定义，不能直接使用
//  ------------------------------------------------------------------


#import <Foundation/Foundation.h>
#import "BLEPublic.h"

typedef NS_ENUM(int, eCalltype)
{
        eCallType_getDeviceID = 0,          
        eCalltype_setDeviceID = 1,          
        eCallType_getDeviceUUID = 2,        
        eCalltype_getPeripheralSuccess = 3, 
        eCallType_connectResult = 4,        
        eCalltype_connectOK = 5,            
        eCallType_UpdateValueForCharac = 6, 
        eCallType_didDisConnect = 7,        
        eCallType_didUpdateRSSI = 8,        
        eCalltype_setDeviceUUID = 9,        
        eCallType_getScanList = 10
};

@interface BLEManager : NSObject<CBCentralManagerDelegate, CBPeripheralDelegate>

+(id)sharedInstance;

-(void)addBLEDevice:(id)bleDevice;

-(BOOL)changeBLEDevice:(int)destDeviceID sourceDeviceID:(int)sourceDeviceID;

-(BOOL)connectDevice:(int)bleDeviceID serviceUUID:(NSString*)serviceUUID localName:(NSString*)localName;

-(BOOL)connectDevice:(int)bleDeviceID peripheralUUID:(NSString*)UUID;

-(BOOL)initConnectWithNameOfRanges:(int)bleDeviceID serviceUUID:(NSString*)serviceUUID localNames:(NSArray*)localNames isRanges:(NSArray*)isRanges;

-(BOOL)initConnectWithScanIndex:(int)bleDeviceID scanIndex:(int)scanIndex;

-(BOOL)startConnect:(int)bleDeviceID isFirstPeripheral:(BOOL)isFirstPeripheral;  // 2013-08-30

-(BOOL)startDiscover:(int)bleDeviceID;

-(BOOL)disconnect:(int)bleDeviceID;

-(BOOL)getIsConnect:(int)bleDeviceID;

-(BOOL)checkExistServiceUUID:(int)bleDeviceID serviceUUID:(NSString*)serviceUUID characteristicUUID:(NSString*)characteristicUUID;

-(BOOL)getScanDeviceList:(int)bleDeviceID scanTime:(float)scanTime;

-(BOOL)getMACAddress:(int)bleDeviceID;

-(BOOL)readRSSI:(int)bleDeviceID;

-(void)notification:(int)bleDeviceID serviceUUID:(int)serviceUUID characteristicUUID:(int)characteristicUUID on:(BOOL)on;

-(void)readValueForCharacteristic:(int)bleDeviceID serviceUUID:(int)serviceUUID characteristicUUID:(int)characteristicUUID;

-(void)writeValueForCharacteristic:(int)bleDeviceID serviceUUID:(int)serviceUUID characteristicUUID:(int)characteristicUUID data:(NSData *)data;

-(void)readValueForDescriptor:(int)bleDeviceID serviceUUID:(int)serviceUUID characteristicUUID:(int)characteristicUUID descriptorUUID:(int)descriptorUUID;

-(void)writeValueForDescriptor:(int)bleDeviceID serviceUUID:(int)serviceUUID characteristicUUID:(int)characteristicUUID descriptorUUID:(int)descriptorUUID data:(NSData *)data;

@end
