//
//  BLEPublic.h
//
//  ------------------------------------------------------------------
//  公共定义类，无需初始化，静态使用
//  ------------------------------------------------------------------

//  ------------------------------------------------------------------
//  是否开启debug调试输出信息的开关：0 - 否； 1 - 是
//  注意：
//      在软件提交AppStore前，或者封装为框架供外部程序使用时，必须检查是否关闭！
//      否则生成的App将有闪退或者崩溃的可能，会导致无法通过上架审核！！！
//  ------------------------------------------------------------------
#ifndef AntiLost_Debug
#define AntiLost_Debug 0

#endif

#import <CoreBluetooth/CoreBluetooth.h>

@interface BLEPublic : NSObject

+(const char *) CBUUIDToString:(CBUUID *) UUID;

+(int) compareCBUUID:(CBUUID *) UUID1 UUID2:(CBUUID *)UUID2;

+(const char *)UUIDToString:(CFUUIDRef)UUID;

+(CFUUIDRef)StringToUUID:(const char*)suuid;

+(BOOL)comparePeripheralUUID:(CBPeripheral *)cbp1 peripheral2:(CBPeripheral *)cbp2;

+(UInt16) swap:(UInt16)s;

+(CBService *) findServiceFromUUID:(CBUUID *)UUID p:(CBPeripheral *)p;

+(CBCharacteristic *) findCharacteristicFromUUID:(CBUUID *)UUID service:(CBService*)service;

+(CBDescriptor *) findDescriptorFromUUID:(CBUUID *)UUID characteristic:(CBCharacteristic *)characteristic;

+(UInt16) CBUUIDToInt:(CBUUID *)UUID;

@end
