//
//  Protocol_BLEDeviceResult.h
//
//  ------------------------------------------------------------------
//  BLEDevice操作结果的返回接口
//  ------------------------------------------------------------------

@protocol Protocol_BLEDeviceResult <NSObject>

//  连接BLE设备成功
-(void)BR_connectOK;

//  连接BLE设备失败，
//  失败原因是 0 - FAILETYPE_FAILTOCONNECT 连接不上设备
//           1 - FAILETYPE_FAILTODISCOVER 查找不到Sevrce
-(void)BR_connectFail:(int)nFAILETYPE;

//  断开BLE设备
-(void)BR_didDisconnect;

//  读取RSSI成功，返回读取的RSSI值
-(void)BR_didUpdateRSSI:(float)value;

//  BD_getScanDeviceList的结果返回
//  返回内容为string类型的MutableArray，每个string的内容是
//  “LocalName,ServiceUUID,UUID,RSSI,TxPower”，中间用逗号分隔
-(void)BR_scanDeviceList:(NSMutableArray *)arrayScanDeviceList;

//  BD_getMACAddress的结果返回
-(void)BR_getMACAddress:(Byte *)address length:(int)length;

@end
