//
//  SubViewController.h
//  Uart_BLE
//
//  Created by lc on 14-6-4.
//
//

#import <UIKit/UIKit.h>
#import "UartData.h"

@interface SubViewController : UIViewController <UITextFieldDelegate>
{
    IBOutlet UIButton *btnCircleSend;       //周期发送
    IBOutlet UIButton *btnStopSend;         //停止发送
    IBOutlet UIButton *btnHexOrASCIIShow;   //十六进制显示还是ascii显示
    
    IBOutlet UITextField *txtTime;          //发送间隔时间
    IBOutlet UITextField *txtSendData;      //发送数据
    IBOutlet UILabel *lblSendDataLength;    //发送字节数:长度
    IBOutlet UITextView *txtReadData;       //收到硬件数据
    
    int nSendDataNumber;                    //记录已经发送了几条数据
    IBOutlet UILabel *lblSendDataNumber;    //已经发送几条数据
    
    //是否周期发送
    BOOL isStartCircleSendData;
    
    //重发定时器
    NSTimer *tmrReSend;
    
    //数据定义最大长度
    int nMaxDataLength;
    
    //是以十六进制显示还是以ascii显示
    BOOL isHexShow;
    
    //接受到的数据的条数
    int nReceiveDataNumbers;
    IBOutlet UILabel *lblReceiveNumber;
    
    //接收到的数据全部存放数组中
    NSMutableArray *receiveDataArray;
    
    //上次显示的最后一条数据
    int nLastDataNumber;
    
    //显示的n条数据
    NSString *strShowData;
    
    //显示的ASCII格式数据
    NSString *strShowASCIIData;
    
    //提示用户数据超过ascii范围,只能以hex方式显示
    UIAlertView *alertHexShow;
}

- (IBAction)CircleSend:(id)sender;          //周期发送
- (IBAction)StopSend:(id)sender;            //停止发送
- (IBAction)ClearScreen:(id)sender;         //清屏
- (IBAction)txtDidEndOnExit:(id)sender;     //隐藏软键盘
- (IBAction)HexSend:(id)sender;             //hex发送
- (IBAction)HexShow:(id)sender;             //十六进制显示
- (IBAction)txtDataTextChange:(id)sender;   //发送数据输入改变触发,用来计算长度

//收到硬件数据
- (void)ReceiveData:(Byte *)bytes length:(int)length recvTime:(NSDate *)recvDate;

//- (IBAction)testRecData:(id)sender;

@end