//
//  SubViewController.m
//  Uart_BLE
//
//  Created by lc on 14-6-4.
//
//

#import "SubViewController.h"

#define iPhone5Dev ([UIScreen instancesRespondToSelector:@selector(currentMode)] ? CGSizeEqualToSize(CGSizeMake(640, 1136), [[UIScreen mainScreen] currentMode].size) : NO)

@interface SubViewController ()

@end

@implementation SubViewController

//static int tempIndex;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self)
    {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    //时间输入键盘为数字键盘
    txtTime.keyboardType = UIKeyboardTypeNumberPad;
    
    //初始化右边导航栏按钮,和返回一个效果
    UIBarButtonItem *rightButton = [[UIBarButtonItem alloc] initWithTitle:@"DisConnect" style:UIBarButtonItemStyleBordered target:self action:@selector(DisConnectDevice)];
    self.navigationItem.rightBarButtonItem = rightButton;
    
    //初始化接收数据的数组
    receiveDataArray = [NSMutableArray new];
        
    //接收数据的textview适应iPhone4/5屏幕大小
    if(!iPhone5Dev)
    {
        txtReadData.frame = CGRectMake(txtReadData.frame.origin.x, txtReadData.frame.origin.y, txtReadData.frame.size.width, 266);
    }
    
    //初始化提示框内容
    alertHexShow = [[UIAlertView alloc] initWithTitle:@"uart_BLE" message:@"数据超过ASCII范围,只能以hex方式显示" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    //每次连接之后都重新计算最大长度
    nMaxDataLength = [uart BD_getDataFullLength];
    strShowData = [NSString new];
    strShowASCIIData = [NSString new];
    isHexShow = YES;
    [btnHexOrASCIIShow setTitle:@"ASCII显示" forState:UIControlStateNormal];
    nSendDataNumber = 0;
    lblSendDataNumber.text = [NSString stringWithFormat:@"已发送%d条数据", nSendDataNumber];
        
    [NSTimer scheduledTimerWithTimeInterval:0.5f target:self selector:@selector(ShowDataToView) userInfo:nil repeats:YES];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    
    //断开连接时候所有界面数据全部显示为最开始时候
    txtReadData.text = @"";
    txtSendData.text = @"";
    txtTime.text = @"";
    [tmrReSend invalidate];
    tmrReSend = nil;
    lblSendDataLength.text = @"字节数:0";
    [self ClearScreen:nil];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - custom method
//接收到硬件数据
- (void)ReceiveData:(Byte *)bytes length:(int)length recvTime:(NSDate *)recvDate
{
    //收到硬件数据添加到数组中,不管显示的部分
    NSString *strData = @"";
    for (int i = 0; i < length; i++)
    {
        strData = [NSString stringWithFormat:@"%@ %02x", strData, bytes[i]];
    }
        
    //开头空格换成冒号:
    if(strData.length == 0) return;
    strData = [strData substringFromIndex:1];
    strData = [@":" stringByAppendingString:strData];
    
    //加日期
    NSDateFormatter *dateFormatter = [NSDateFormatter new];
    [dateFormatter setDateFormat:@"HH-mm-ss-SSS"];
    NSString *strDate = [dateFormatter stringFromDate:recvDate];
    [receiveDataArray addObject:[strDate stringByAppendingString:strData]];
    lblReceiveNumber.text = [NSString stringWithFormat:@"收到%d条数据", receiveDataArray.count];
}

//显示数据到界面
- (void)ShowDataToView
{
    //新增显示几条数据
    int number = 0;
    int nCurrentReceiveDataArrayCount = receiveDataArray.count;
    number =  nCurrentReceiveDataArrayCount - nLastDataNumber;
    
    //如果没有接收到新的数据,不刷新列表,防止数据接收区域抖动.
    if (number == 0)
    {
        return;
    }
    
    for (int i = 0; i < number; i++)
    {
        NSRange range = [strShowData rangeOfString:@"\n"];
        if (range.length != 0 && nCurrentReceiveDataArrayCount > 500)
        {
            strShowData = [strShowData substringFromIndex:range.location + 1];
        }
        strShowData = [strShowData stringByAppendingString:receiveDataArray[nLastDataNumber + i]];
        strShowData = [strShowData stringByAppendingString:@"\n"];
        
        NSRange hexRange = [strShowASCIIData rangeOfString:@"\n"];
        if (hexRange.length != 0 &&  nCurrentReceiveDataArrayCount > 500)
        {
            strShowASCIIData = [strShowASCIIData substringFromIndex:hexRange.location + 1];
        }
        strShowASCIIData = [strShowASCIIData stringByAppendingString:[[receiveDataArray[nLastDataNumber + i] componentsSeparatedByString:@":"] objectAtIndex:0]];
        strShowASCIIData = [strShowASCIIData stringByAppendingString:@":"];
        strShowASCIIData = [strShowASCIIData stringByAppendingString:[self HexToASCII:[[receiveDataArray[nLastDataNumber + i] componentsSeparatedByString:@":"] objectAtIndex:1]]];
        strShowASCIIData = [strShowASCIIData stringByAppendingString:@"\n"];
    }
    
    if (isHexShow)
    {
        txtReadData.text = strShowData;
    }
    else
    {
        txtReadData.text = strShowASCIIData;
    }
    nLastDataNumber = nCurrentReceiveDataArrayCount;
    [txtReadData scrollRangeToVisible:NSMakeRange(txtReadData.text.length, 1)];
}

- (void)DisConnectDevice
{
    //断开连接并退回到上一个界面
    if ([uart BD_getIsConnected])
    {
        [uart BD_disConnect];
    }
    [self.navigationController popToRootViewControllerAnimated:YES];
}

//周期发送,不能重复点击,只有在停止之后才能再开始
- (IBAction)CircleSend:(id)sender
{
    nSendDataNumber = 0;
    lblSendDataNumber.text = [NSString stringWithFormat:@"已发送%d条数据", nSendDataNumber];
    //定时周期发送数据
    if (txtTime.text.length == 0)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"uart_BLE" message:@"请输入时间周期,单位毫秒" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
        [alert show];
        return;
    }
    
    [btnCircleSend setEnabled:NO];
    [btnStopSend setEnabled:YES];
    if (!tmrReSend)
    {
        tmrReSend = [NSTimer scheduledTimerWithTimeInterval:[txtTime.text intValue] / 1000.f target:self selector:@selector(SendData) userInfo:nil repeats:YES];
    }
}

//hex发送,就是发送一次
- (IBAction)HexSend:(id)sender
{
//    tempIndex = 0;
//    [NSTimer scheduledTimerWithTimeInterval:0.1f target:self selector:@selector(GetData) userInfo:nil repeats:NO];
    [self SendData];
}

//停止发送,点击之后周期发送按钮为可点击
- (IBAction)StopSend:(id)sender
{
    [btnCircleSend setEnabled:YES];
    [btnStopSend setEnabled:NO];
    [tmrReSend invalidate];
    tmrReSend = nil;
}

//发送数据
- (void)SendData
{
    //如果输入不合法,定时器停止
    if (![self CheckTxtData])
    {
        [tmrReSend invalidate];
        tmrReSend = nil;
        return;
    }

    NSMutableArray *dataArray = [NSMutableArray new];
    for (int i = 0; i < txtSendData.text.length; i = i + 2)
    {
        [dataArray addObject:[txtSendData.text substringWithRange:NSMakeRange(i, 2)]];
    }
    
    //如果长度大于20,分多次发送
    for (int i = 0; i <= dataArray.count / nMaxDataLength; i++)
    {
        char data[dataArray.count];
        int length = 0;
        
        if (i == dataArray.count / nMaxDataLength)
        {
            length = dataArray.count % nMaxDataLength;
        }
        else
        {
            length = nMaxDataLength;
        }
        
        for (int j = 0; j < length; j++)
        {
            data[j] = (unsigned int)strtoul([dataArray[j + i * nMaxDataLength] UTF8String],0,16);
        }
        
        lblSendDataNumber.text = [NSString stringWithFormat:@"已发送%d条数据", ++nSendDataNumber];
        [uart BD_sendFullLengthData:data length:length];
    }
}

//检查输入的东西是否合格
- (BOOL)CheckTxtData
{
    //因为输入是十六进制数,所以必须是下面的字符串中的一个
    NSString *stringFormat = @"0123456789abcdefABCDEF";

    //没有最大长度限制,如果超过20字节分多次发送.
    if (txtSendData.text.length == 0)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"uart_BLE" message:@"发送的数据不能为0!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
        [alert show];
        return NO;
    }
    
    if (txtSendData.text.length % 2 == 1)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"uart_BLE" message:@"输入内容个数不能是单数!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
        [alert show];
        return NO;
    }
    
    for (int i = 0; i < txtSendData.text.length; i++)
    {
        if ([stringFormat rangeOfString:[txtSendData.text substringWithRange:NSMakeRange(i, 1)]].length == 0) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"uart_BLE" message:@"输入内容应该是十六进制整数,两位一组!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
            [alert show];
            return NO;
        }
    }
    
    return YES;
}

//hex显示/ascii显示
- (IBAction)HexShow:(id)sender
{
    [btnHexOrASCIIShow setEnabled:NO];
    
    if (isHexShow)
    {
        isHexShow = NO;
        [btnHexOrASCIIShow setTitle:@"十六进制显示" forState:UIControlStateNormal];
    }
    else
    {
        isHexShow = YES;
        [btnHexOrASCIIShow setTitle:@"ASCII显示" forState:UIControlStateNormal];
    }
        
    //设置一秒钟的时间让按钮不可点,防止点击过快数据显示混乱
    [self performSelector:@selector(setButtonEnable) withObject:nil afterDelay:1.f];
}

//设置ASCII/Hex显示按钮可点击
- (void)setButtonEnable
{
    [btnHexOrASCIIShow setEnabled:YES];
}

//ascii转换到hex
- (NSString *)ASCIIToHex:(NSString *)string
{
    NSString *result = @"";
    NSArray *resultArray = [string componentsSeparatedByString:@" "];
    for (int i = 0; i < resultArray.count; i++)
    {
        const char *tempData = [resultArray[i] UTF8String];
        result = [NSString stringWithFormat:@"%@ %02x", result, *tempData];
    }
    
    return [result substringFromIndex:1];
}

//hex转换到ascii
- (NSString *)HexToASCII:(NSString *)string
{
    NSString *result = @"";
    NSArray *resultArray = [string componentsSeparatedByString:@" "];
    for (int i = 0; i < resultArray.count; i++)
    {
        if (strtoul([resultArray[i] UTF8String],0,16) > 0x7f)
        {
            return @"";
        }
        
        //使用c语言函数把十六进制数字的字符串转换为10进制无符号整数
        result = [NSString stringWithFormat:@"%@ %c", result, (char)strtoul([resultArray[i] UTF8String],0,16)];
    }
    
    //去开头空格
    return [result substringFromIndex:1];
}
 
//清屏
- (IBAction)ClearScreen:(id)sender
{
    txtReadData.text = @"";
    [receiveDataArray removeAllObjects];
    nReceiveDataNumbers = 0;
    nLastDataNumber = 0;
    strShowData = @"";
    strShowASCIIData = @"";
    lblReceiveNumber.text = @"收到0条数据";
}

//点击键盘的return健的时候影藏输入框的软键盘
- (IBAction)txtDidEndOnExit:(id)sender
{
    [sender resignFirstResponder];
}

//输入框值改变触发,计算输入框内容的长度
- (IBAction)txtDataTextChange:(id)sender
{
    lblSendDataLength.text = [NSString stringWithFormat:@"字节数:%d", txtSendData.text.length / 2];
}

//触摸view的任何地方,隐藏所有输入的软键盘
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    [txtSendData resignFirstResponder];
    [txtTime resignFirstResponder];
    [txtReadData resignFirstResponder];
}

@end
